#include<bits/stdc++.h>
#define ll long long
using namespace std;
int promena(char a[], int n)
{
int i;
int promene = 0;
for (i = 0; i < n; i++)
{
    if (a[i] == '1')
    {
        int j;
        for(j=i+1; j<n; j++)
        {
            if(a[j]=='0')
                break;
        }
        i = j-1;
        promene++;
        }
    }
    return promene;
}
int main(){
ios::sync_with_stdio(0);
cin.tie(0);
int n,c,q,z;
string s;
cin >> n >> c >> q>>s;
int l[q],r[q],zbir;
char a[n];
zbir=z=0;
for(int i=0;i<n;++i){
    a[i] = s[i];
}
for(int i=0;i<q;++i){
    cin >> l[i] >> r[i];
}
for(int i=0;i<q;++i){
    for(int j=l[i]-1; j<=r[i]-1;++j){
        if(a[j] == '0'){
            a[j]='1';
        }
        else{
            a[j]='0';
        }
    }
    cout << promena(a,n) << endl;
}
    return 0;
}